> ## Documentation Index
> Fetch the complete documentation index at: https://docs.vaults.fyi/llms.txt
> Use this file to discover all available pages before exploring further.

# Get borrow market historical data

> Retrieves paginated historical data for one borrow market asset on one network.



## OpenAPI

````yaml https://api.vaults.fyi/beta/documentation/json get /beta/borrow/markets/historical/{network}/{marketId}/{assetAddress}
openapi: 3.0.3
info:
  title: Vaults.fyi Beta API
  version: 0.1.0
  description: >-
    Beta API endpoints for features in testing. These endpoints are not included
    in the main API documentation and may change without notice.
servers:
  - url: https://api.vaults.fyi
    description: Vaults.fyi Beta API
security: []
tags:
  - name: Borrow Markets
  - name: The Deep
  - name: Fixed Term (Pendle)
  - name: Portfolio
  - name: SVM
paths:
  /beta/borrow/markets/historical/{network}/{marketId}/{assetAddress}:
    get:
      tags:
        - Borrow Markets
      summary: Get borrow market historical data
      description: >-
        Retrieves paginated historical data for one borrow market asset on one
        network.
      operationId: getBorrowMarketHistoricalData
      parameters:
        - schema:
            type: integer
            minimum: 0
            default: 0
          in: query
          name: page
          required: false
          description: Page number (starting from 0)
        - schema:
            type: integer
            exclusiveMinimum: true
            minimum: 0
            maximum: 20000
            default: 50
          in: query
          name: perPage
          required: false
          description: Number of items per page
        - schema:
            type: string
            enum:
              - 1hour
              - 1day
              - 1week
            default: 1hour
          in: query
          name: granularity
          required: false
          description: >-
            Granularity for historical data (even intervals starting from epoch
            0). Possible values: 1hour, 1day, 1week
        - schema:
            type: integer
            default: 0
          in: query
          name: fromTimestamp
          required: false
          description: >-
            Timestamp for the start of the time period for which data will be
            fetched
        - schema:
            type: integer
          in: query
          name: toTimestamp
          required: false
          description: >-
            Timestamp for the end of the time period for which data will be
            fetched
        - schema:
            type: string
            enum:
              - mainnet
              - optimism
              - arbitrum
              - polygon
              - gnosis
              - base
              - unichain
              - swellchain
              - celo
              - worldchain
              - berachain
              - ink
              - bsc
              - hyperliquid
              - plasma
              - avalanche
              - katana
              - linea
              - mega-eth
              - monad
              - etherlink
          in: path
          name: network
          required: true
          description: Canonical network slug
        - schema:
            type: string
            minLength: 1
          in: path
          name: marketId
          required: true
          description: Canonical market identifier
        - schema:
            type: string
            pattern: ^0x[a-fA-F0-9]{40}$
          in: path
          name: assetAddress
          required: true
          description: Canonical asset address within the borrow market
      responses:
        '200':
          description: >-
            Historical data for a single borrow market asset, paginated by
            timestamp
          content:
            application/json:
              schema:
                type: object
                properties:
                  itemsOnPage:
                    type: integer
                    description: Number of items on the current page
                  nextPage:
                    type: integer
                    description: Next page number
                  data:
                    type: array
                    items:
                      type: object
                      properties:
                        timestamp:
                          type: integer
                          description: Timestamp of the historical data point
                        blockNumber:
                          type: string
                          description: Block number of the historical data point
                        supplyRate:
                          type: number
                          minimum: 0
                          description: Supply rate for the market asset
                        borrowRate:
                          type: number
                          minimum: 0
                          description: Borrow rate for the market asset
                        utilizationRate:
                          type: number
                          minimum: 0
                          description: >-
                            Utilization rate derived from supplied and borrowed
                            balances
                        totalSupplied:
                          type: object
                          properties:
                            usd:
                              type: string
                              description: >-
                                USD value of the amount. Omitted when no price
                                is available.
                            native:
                              type: string
                              description: Amount denominated in asset precision
                          required:
                            - native
                          additionalProperties: false
                          description: Total supplied balance in native units and USD
                        totalBorrowed:
                          type: object
                          properties:
                            usd:
                              type: string
                              description: >-
                                USD value of the amount. Omitted when no price
                                is available.
                            native:
                              type: string
                              description: Amount denominated in asset precision
                          required:
                            - native
                          additionalProperties: false
                          description: Total borrowed balance in native units and USD
                        supplyIndex:
                          type: number
                          minimum: 0
                          description: Supply index for the market asset
                        borrowIndex:
                          type: number
                          minimum: 0
                          description: Borrow index for the market asset
                      required:
                        - timestamp
                        - blockNumber
                        - supplyRate
                        - borrowRate
                        - utilizationRate
                        - totalSupplied
                        - totalBorrowed
                        - supplyIndex
                        - borrowIndex
                      additionalProperties: false
                      description: Array of items on the current page
                required:
                  - itemsOnPage
                  - data
                additionalProperties: false
                description: >-
                  Historical data for a single borrow market asset, paginated by
                  timestamp
        '400':
          description: Default Response
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      statusCode:
                        type: number
                      error:
                        type: string
                        enum:
                          - Bad Request
                      message:
                        type: string
                      errorId:
                        type: string
                    required:
                      - statusCode
                      - error
                      - message
                    additionalProperties: false
                  - {}
        '401':
          description: Default Response
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      error:
                        type: string
                        enum:
                          - Unauthorized
                      message:
                        type: string
                        enum:
                          - >-
                            An API key is required to access this service. Sign
                            up at https://portal.vaults.fyi/signup to generate a
                            key. We offer a Pay-As-You-Go plan so you only pay
                            for what you use, with no commitments.
                      errorId:
                        type: string
                    required:
                      - error
                      - message
                    additionalProperties: false
                  - {}
        '402':
          description: Default Response
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      x402Version:
                        anyOf:
                          - type: number
                          - type: string
                      error:
                        type: string
                      resource:
                        type: object
                        properties:
                          url:
                            type: string
                          description:
                            type: string
                          mimeType:
                            type: string
                          serviceName:
                            type: string
                          tags:
                            type: array
                            items:
                              type: string
                          iconUrl:
                            type: string
                        required:
                          - url
                        additionalProperties: false
                      accepts:
                        anyOf:
                          - type: array
                            items:
                              type: object
                              properties:
                                scheme:
                                  type: string
                                  enum:
                                    - exact
                                network:
                                  type: string
                                amount:
                                  type: string
                                payTo:
                                  type: string
                                maxTimeoutSeconds:
                                  type: number
                                asset:
                                  type: string
                                extra:
                                  type: object
                                  properties:
                                    name:
                                      type: string
                                    version:
                                      type: string
                                  required:
                                    - name
                                    - version
                                  additionalProperties: false
                              required:
                                - scheme
                                - network
                                - amount
                                - payTo
                                - maxTimeoutSeconds
                                - asset
                              additionalProperties: false
                          - {}
                      extensions:
                        type: object
                        additionalProperties: {}
                    required:
                      - x402Version
                      - resource
                    additionalProperties: false
                  - {}
        '403':
          description: Default Response
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      error:
                        type: string
                        enum:
                          - Forbidden
                      message:
                        type: string
                        enum:
                          - >-
                            This API key has exhausted its available credits. To
                            resume service, please visit
                            https://portal.vaults.fyi/signup to top-up your
                            credits
                      errorId:
                        type: string
                    required:
                      - error
                      - message
                    additionalProperties: false
                  - {}
        '404':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    enum:
                      - Not Found
                  message:
                    type: string
                required:
                  - error
                  - message
                additionalProperties: false
        '408':
          description: Default Response
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      message:
                        type: string
                      errorId:
                        type: string
                    additionalProperties: false
                  - {}
        '422':
          description: Default Response
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      statusCode:
                        type: number
                      error:
                        type: string
                        enum:
                          - Unprocessable Entity
                      message:
                        type: string
                      errorId:
                        type: string
                    required:
                      - statusCode
                      - error
                      - message
                    additionalProperties: false
                  - {}
        '500':
          description: Default Response
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      error:
                        type: string
                        enum:
                          - Internal Server Error
                      message:
                        type: string
                      errorId:
                        type: string
                    required:
                      - error
                      - message
                    additionalProperties: false
                  - {}
        '503':
          description: Default Response
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      statusCode:
                        type: number
                      error:
                        type: string
                        enum:
                          - Service Unavailable
                      message:
                        type: string
                      errorId:
                        type: string
                    required:
                      - statusCode
                      - error
                      - message
                    additionalProperties: false
                  - {}
      security:
        - apiKey: []
components:
  securitySchemes:
    apiKey:
      type: apiKey
      name: x-api-key
      in: header

````